/**
 * Copyright (c) 2020 Raspberry Pi (Trading) Ltd.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include <stdio.h>
#include <string.h>
#include "pico/stdlib.h"

bool connection78 = false;
bool connection49 = false;
bool connection510 = false;
bool connection611 = false;
bool connection1213 = false;
bool printed = false;
bool blink = false;

const int LOW = 0;
const int HIGH = 1;
const uint LED_PIN = 25;

char s1[5] = { 49, 56, 54, 48, 0 };
char s2[5] = { 49, 52, 57, 56, 0 };
char s3[5] = { 49, 56, 54, 57, 0 };
char s4[5] = { 49, 57, 54, 48, 0 };
char s12[5] = { 32, 30, 32, 32, 0 };
char s5[] = "You found all the points on the world map, wait to reveal a message to humanity:";
char s6[102]  = { 84, 104, 101, 32, 109, 97, 105, 110, 32, 99, 97, 117,          \
                  115, 101, 32, 111, 102, 32, 116, 104, 101, 32, 109, 111, 115,  \
                  116, 32, 118, 105, 111, 108, 101, 110, 116, 32, 99, 114,       \
                  105, 109, 101, 115, 32, 105, 115, 32, 97, 108, 119, 97, 121,   \
                  115, 32, 97, 32, 98, 101, 108, 105, 101, 102, 32, 116, 104,     \
                  97, 116, 32, 115, 111, 109, 101, 32, 112, 101, 111, 112, 108,  \
                  101, 32, 97, 114, 101, 32, 98, 101, 116, 116, 101, 114,        \
                  32, 116, 104, 97, 110, 32, 111, 116, 104, 101, 114, 115, 46, 0 };

void setup() { 
  stdio_init_all();
  gpio_init( LED_PIN );
  gpio_set_dir( LED_PIN, GPIO_OUT );
  for ( int i = 4; i<14; i++ )
    gpio_init( i );

  gpio_set_dir( 4, GPIO_OUT );
  gpio_set_dir( 5, GPIO_OUT );
  gpio_set_dir( 6, GPIO_OUT );
  gpio_set_dir( 7, GPIO_OUT );
  gpio_set_dir( 12, GPIO_OUT );

  gpio_set_dir( 8, GPIO_IN );
  gpio_set_dir( 9, GPIO_IN );
  gpio_set_dir( 10, GPIO_IN );
  gpio_set_dir( 11, GPIO_IN );
  gpio_set_dir( 13, GPIO_IN );
} 

bool checkConnection( int a, int b ) {
  bool b1, b2, b3, b4;
  int x;
  gpio_put( a, LOW );
  x = gpio_get( b );
  b1 = ( x == LOW );
  gpio_put( a, HIGH );
  x = gpio_get( b );
  b2 = ( x > LOW );
  gpio_put( a, LOW );
  x = gpio_get( b );
  b3 = ( x == LOW );
  gpio_put( a, HIGH );
  x = gpio_get( b );
  b4 = ( x > LOW );
  return b1 && b2 && b3 && b4;
}


void loop() {
  if ( !printed ) {
    if ( !checkConnection( 4, 9 ) && !checkConnection( 5, 10 ) && 
         !checkConnection( 6, 11 ) && !checkConnection( 12, 13 ) && 
         !connection78 && checkConnection( 7, 8 )) {
      connection78 = true;
      printf( "%s\n", s1 );
      gpio_put( LED_PIN, HIGH );
      sleep_ms( 1000 );

    }
    if ( !connection49 && !checkConnection( 5, 10 ) && 
         !checkConnection( 6, 11 ) && !checkConnection( 12, 13 ) &&
         checkConnection( 4, 9 ) && checkConnection( 7, 8 ))  {
      connection49 = true;
      printf( "%s\n",s2 );
      gpio_put( LED_PIN, HIGH );
      sleep_ms( 1000 );

    }
    if ( !checkConnection( 6, 11 ) && !connection510  && !checkConnection( 12, 13 ) &&
         checkConnection( 5, 10 ) && checkConnection( 7, 8 ) && checkConnection( 4, 9 )) {
      connection510 = true;
      printf( "%s\n", s3 );
      gpio_put( LED_PIN, HIGH );
      sleep_ms( 1000 );
    }

    if ( !connection611 && !checkConnection( 12, 13 ) &&
         checkConnection( 6, 11 ) && checkConnection( 7, 8 ) && 
         checkConnection( 4, 9 ) && checkConnection( 5, 10 ) ) {
      connection611 = true;
      printf( "%s\n", s4 );
      gpio_put( LED_PIN, HIGH );
      sleep_ms( 1000 );
    }

    if ( !connection1213 && checkConnection( 12, 13 ) &&
         checkConnection( 6, 11 ) && checkConnection( 7, 8 ) && 
         checkConnection( 4, 9 ) && checkConnection( 5, 10 )) {
      connection1213 = true;
      printf( "%s\n", s12 );
      gpio_put( LED_PIN, HIGH );
      sleep_ms( 1000 );
    }

    if ( connection78 && connection49 && connection510 && 
         connection611 && connection1213 && !printed ) {
        printf( "%s\n", s5 );
        printf( "\n" );
        sleep_ms( 5000 );
        for ( int i=0; i < strlen( s6 ); i++ ) {
          printf( "%c", s6[i] );
          sleep_ms( 1000 ); 
        }
        printf( "\n" );
        printf( "\n" );
        printf("Congratulations!\n");
        printed = true;
    }
  }

  if ( blink ){
    gpio_put( LED_PIN, LOW );
    blink = false;
  } else {
    gpio_put( LED_PIN, HIGH );
    blink = true;
  }
  sleep_ms(250);  
}

int main() {
    setup();
    while (true) {
        loop();
    }
    return 0;
}

