#include <Wire.h>
#include <LiquidCrystal_I2C.h>

bool connection78 = false;
bool connection49 = false;
bool connection510 = false;
bool connection611 = false;
bool printed = false;
bool ledOn = false;

int light, key;

char s1[5] = { 49, 56, 54, 48, 0 };
char s2[5] = { 49, 52, 57, 56, 0 };
char s3[5] = { 49, 56, 54, 57, 0 };
char s4[5] = { 49, 57, 54, 48, 0 };
char s5[] = "You found all the points on the world map, wait to reveal a message to humanity:";
char s6[102]  = { 84, 104, 101, 32, 109, 97, 105, 110, 32, 99, 97, 117,          \
                  115, 101, 32, 111, 102, 32, 116, 104, 101, 32, 109, 111, 115,  \
                  116, 32, 118, 105, 111, 108, 101, 110, 116, 32, 99, 114,       \
                  105, 109, 101, 115, 32, 105, 115, 32, 97, 108, 119, 97, 121,   \
                  115, 32, 97, 32, 98, 101, 108, 105, 101, 102, 32, 116, 104,     \
                  97, 116, 32, 115, 111, 109, 101, 32, 112, 101, 111, 112, 108,  \
                  101, 32, 97, 114, 101, 32, 98, 101, 116, 116, 101, 114,        \
                  32, 116, 104, 97, 110, 32, 111, 116, 104, 101, 114, 115, 46, 0 };

LiquidCrystal_I2C lcd(0x27, 16, 2);
int i, k, l;

void setup() { 
  //Serial.begin( 9600 );
  lcd.init();
  pinMode( 2, OUTPUT );
  pinMode( 3, OUTPUT );
  pinMode( 12, OUTPUT );
  pinMode( 13, INPUT );
} 

bool checkConnection( int a, int b ) {
  bool b1, b2, b3, b4;
  int x;
  pinMode( a, OUTPUT );
  pinMode( b, INPUT_PULLUP );
  digitalWrite( a, LOW );
  x = digitalRead( b );
  b1 = ( x == LOW );
  digitalWrite( a, HIGH );
  x = digitalRead( b );
  b2 = ( x == HIGH );
  digitalWrite( a, LOW );
  x = digitalRead( b );
  b3 = ( x == LOW );
  digitalWrite( a, HIGH );
  x = digitalRead( b );
  b4 = ( x == HIGH );
  return b1 && b2 && b3 && b4;
}


void loop() {
  light = analogRead(A0);
  key = digitalRead(13);
  
  if ( !printed ) {
    if ( !checkConnection( 4, 9 ) && !checkConnection( 5, 10 ) && !checkConnection( 6, 11 ) && !connection78 && checkConnection( 7, 8 )) {
      digitalWrite( 2, HIGH );
      ledOn = true;
      delay(500);
      digitalWrite(3, LOW);
      if ((light < 100 || key == 0) && ledOn){
        connection78 = true;
        lcd.backlight();
        lcd.setCursor(0, 0);
        lcd.print(s1); 
        //Serial.println( s1 );
        ledOn = false;
        digitalWrite(2, LOW);
      }
    }
    if ( !connection49 && !checkConnection( 5, 10 ) && !checkConnection( 6, 11 ) && checkConnection( 4, 9 ) && checkConnection( 7, 8 ))  {
      
      digitalWrite( 2, HIGH );
      ledOn = true;
      delay(500);
      digitalWrite(3, LOW);
      if ((light < 100 || key == 0) && ledOn){
        connection49 = true;
        lcd.setCursor(8, 0);
        lcd.print(s2);
        //Serial.println( s2 );
        ledOn = false;
        digitalWrite(2, LOW);
      }
    }
    if ( !checkConnection( 6, 11 ) && !connection510  && checkConnection( 5, 10 ) && checkConnection( 7, 8 ) && checkConnection( 4, 9 )) {
      digitalWrite( 2, HIGH );
      ledOn = true;
      delay(500);
      digitalWrite(3, LOW);
      if ((light < 100 || key == 0) && ledOn){
        connection510 = true;
        lcd.setCursor(4, 1);
        lcd.print(s3);
        //Serial.println( s3 );
        ledOn = false;
        digitalWrite(2, LOW);
      }
    }
    if ( !connection611 && checkConnection( 6, 11 ) && checkConnection( 7, 8 ) && checkConnection( 4, 9 ) && checkConnection( 5, 10 ) && connection510 ) {
      digitalWrite( 2, HIGH );
      ledOn = true;
      delay(500);
      digitalWrite(3, LOW);
      if ((light < 100 || key == 0) && ledOn){
        connection611 = true;
        lcd.setCursor(12, 1);
        lcd.print(s4);
        //Serial.println( s4 );
        ledOn = false;
        digitalWrite(2, LOW);
      }
    }
    
    if ( connection78 && connection49 && connection510 && connection611 && !printed ) {
        //Serial.println( s5 );
        //Serial.println();
        delay( 1000 );
        for ( int i=0; i<5; i++ ){
          digitalWrite( 2, LOW );
          delay(500);
          digitalWrite( 2, HIGH );
        }
        delay( 2000 );

        for ( i=0; i < strlen( s6 ); i++ ) {
          k = i%16;
          l = i%32;
          if (l<16)
            l = 0;
          else
            l = 1;
          //Serial.print( s6[i] );
          lcd.setCursor(k, l);
          lcd.print( s6[i] );
          delay( 500 ); 
        }
        for ( i = 0; i<11; i++){
          lcd.print(" ");
          delay(500);
        }

        
        //for ( int i=0; i < strlen( s6 ); i++ ) {
          //Serial.print( s6[i] );
          //delay( 1000 ); 
        //}
        
        //Serial.println();
        //Serial.println();
        //Serial.println("Congratulations!");
        lcd.setCursor(0, 1);
        lcd.print("Congratulations!");
        
        printed = true;
        delay(2000);
        lcd.noBacklight();
    }
  }
  delay(200);  
}
